#!/usr/bin/perl -w

#use threads;
#use Net::DNS;
#use Net::Telnet;
#use Net::IP;
use Net::DNS;
use IO::Socket::INET6;
use Text::Iconv;

# 參數設定
$RETRANS = 3;  # 重傳次數
$RETRY = 3; # 重試次數
$TCPTIMEOUT = 6; # IPv6 網頁連線逾時時間單位秒
@DNS = [qw(163.17.40.1 2001:288:5400::1 2001:288:5400::2 163.17.40.2)];  # 請填入DNS 伺服器
# Config End---------------Program Start vvvvv Do not modify if you know nothing below.

$IsOk=0;
%ERR_Code=(
	2=>"已和網頁伺服器建立IPv6連線，但無法取回網頁標頭",
	1=>"網頁IPv6介面正常，能正常取回資料",
	0=>"無法取得正確的檢測結果，參數錯誤。",
	-1=>"DNS無法查詢，此網域不存在(x)",
    -2=>"無法和網頁伺服器IPv6介面建立連線",
    -3=>"DNS無法取得IPv6之AAAA記錄(x)",
    -4=>"DNS查詢失敗，此網域無AAAA記錄，僅有A記錄",
    -5=>"DNS查詢失敗，無此網域，或無位址記錄",
);

#print "WWW/DNS on IPv6, start checking...\n";

if(  !$ARGV[0] )  { print "0"; exit; }
$chkwww=$ARGV[0];
my $converter = Text::Iconv->new("Big5","UTF-8");

my $resolver = Net::DNS::Resolver->new(
  nameservers => @DNS,
  retrans => $RETRANS,
  retry => $RETRY,
);

$IsOk = &CheckHasAAAA( $chkwww);
if( $IsOk==1) { print $IsOk.",". &GetWWWTitleOnIPv6($chkwww);}
else{ print $IsOk; }

exit;

print $ERR_Code{$IsOk};
#print "\n";
#$IsOk = &CheckDNSQueryOnIPv6( $chkwww );
#if($IsOk >0){print "此網域可用IPv6網路直接查詢";}
#else {print "此網域無法使用IPv6網路直接查詢";}

sub CheckDNSQueryOnIPv6{
  $chkwww = shift;
  $query = $resolver->query( $chkwww, 'NS', 'IN');
  if ($query) {
    foreach my $rr ($query->answer) {
	  print "$rr";
      if($rr->type eq "NS"){ print $rr->nsdname."\n"; }
	  if($rr->type eq "A"){ print $rr->address."\n"; }
    }
	print $query->answerfrom;
    return 1;
  }else { return -1; }
}

sub DNSAddressQuery{
  my $Rec = shift;
  my $RR = shift;
  my $run=0;
  my $query=undef;
  my $loopmax=0;
  do{
    $query = $resolver->query( $Rec, $RR, 'IN');
	if ($query) {
      foreach my $rr ($query->answer) {
        if($rr->type eq "CNAME"){$run=1; $Rec=$rr->cname; }
        else{$run=0;}
        next unless $rr->type eq $RR;
        #print $rr->address;
	    return $rr->address;
      }
	}else{ return -1; }
    $loopmax ++;
  }while( $run==1 && $loopmax<10);
}

sub CheckHasAAAA{
  $chkwww = shift;
  my $aaaa="";
  my $run=0;
  if( ($aaaa= &DNSAddressQuery($chkwww,"AAAA")) ne -1){ 
	  return &CheckHasIPv6WWW($aaaa);
  }else{
    if( &DNSAddressQuery($chkwww,"A") eq -1){return -5;}
    else{ return -4;}
  }
}

sub CheckHasIPv6WWW{
	$aaaa = shift;
      $sock = IO::Socket::INET6->new(
        PeerAddr => $aaaa,
        PeerPort => 'http(80)',
        Proto    => 'tcp',
        Timeout => $TCPTIMEOUT
      ) or return -2;
      print $sock "HEAD / HTTP/1.1\r\nHost:$aaaa\r\nConnection: close\r\n\r\n";
      while (<$sock>)
      {
#        print $_;
		$sock->shutdown(1);
        return 1;
      }
      $sock->shutdown(1);
      return 2;
}

sub GetWWWTitleOnIPv6{
    $aaaa = shift;
    $sock = IO::Socket::INET6->new(
        PeerAddr => $aaaa,
        PeerPort => 'http(80)',
        Proto    => 'tcp',
        Timeout => $TCPTIMEOUT
    ) or return -1;
    print $sock "GET / HTTP/1.1\r\nHost:$aaaa\r\nConnection: close\r\n\r\n";
    $IsBig5=0;
    $Title="";
    while (<$sock>)
    {
#      print $_;
      if( $_ =~ /<meta\s+http-equiv="?Content-Type"?\s+.*charset=(big5)"?\s*\/?>/i){ $IsBig5=1; }
      if( $_ =~ /<TITLE>([^<]+)<\/TITLE>/i){ $Title=$1; }
      if( $_ =~ /<\/head>/i ){
        if($IsBig5 ==1){ return $converter->convert( $Title);}
        return $Title;
      }
    }
    $sock->shutdown(1);
    return -1;
}

